/***************************************************************************
 *   Copyright (C) 2009 by Stephen Allewell                                *
 *   stephen@mirramar.fsnet.co.uk                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef PATTERNLISTVIEWITEM_H
#define PATTERNLISTVIEWITEM_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qstringlist.h>
#include <klistview.h>
#include "patternfile.h"

class LibraryPattern;
class KXStitchDragObject;
class PreviewIconViewItem;

class PatternListViewItem : public KListViewItem
{
public:
  PatternListViewItem(QListView *parent, QString name);
  PatternListViewItem(QListViewItem *parent, QString name);
  ~PatternListViewItem();

  int maxHeight();
  LibraryPattern *findCharacter(int key, Qt::ButtonState modifiers);
  LibraryPattern *first();
  LibraryPattern *next();

  void addPath(QString path);
  QString path();
  QStringList paths();
  void addPattern(KXStitchDragObject *pattern);
  void addPattern(LibraryPattern *pattern);
  void deletePattern(PreviewIconViewItem *iconViewItem);

private:
  PatternFile *writablePath();

  QPtrList<PatternFile> m_patternFiles;
};

#endif
