/***************************************************************************
 *   Copyright (C) 2009 by Stephen Allewell                                *
 *   stephen@mirramar.fsnet.co.uk                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "previewiconview.h"
#include "configuration.h"
#include "kxstitchdragobject.h"
#include "librarypattern.h"

PreviewIconViewItem::PreviewIconViewItem(QIconView *parent, LibraryPattern *libraryPattern)
  : KIconViewItem(parent)
{
  setLibraryPattern(libraryPattern);
}

void PreviewIconViewItem::setLibraryPattern(LibraryPattern *libraryPattern)
{
  m_libraryPattern = libraryPattern;
  setPixmap(KXStitchDragObject(libraryPattern->data()).encodedData("image/png"));
}

LibraryPattern *PreviewIconViewItem::libraryPattern()
{
  return m_libraryPattern;
}


bool PreviewIconViewItem::acceptDrop(const QMimeSource *mimeSource)
{
/* don't accept anything yet
    if ( mimeSource->provides( "application/kxstitch" ) )
        return true;
*/
  return false;
}

void PreviewIconViewItem::dropped(QDropEvent *event, const QValueList<QIconDragItem> &)
{
    // if overwrite of patterns is enabled
    // overwrite this one with the dropped one
}

PreviewIconView::PreviewIconView(QWidget *parent, QString name)
  : KIconView(parent, name)
{
}

void PreviewIconView::setScaleSize(int scaleSize)
{
  m_scaleSize = scaleSize;
}

QDragObject *PreviewIconView::dragObject()
{
  KXStitchDragObject *dragObject = new KXStitchDragObject(static_cast<PreviewIconViewItem*>(currentItem())->libraryPattern()->data(), this);
  dragObject->setScale(m_scaleSize);
  return dragObject;
}
